#!/usr/bin/env python2.4
#
# -*-Mode:Python-*-
#
# TODO:
#   o regular expressions for type ins.
#   o improve still and choice resource loading
#	o Threshold for recognition should be lower.  so it doesn't always match
#	  but instead says not-recognized.  sucks to always go to help.
#   o Hack HVite to record input.  Have HVite running all the time, signalling
#     when it hears something.


import sys, string, time, commands, os, re, subprocess, signal, select
import socket
from optparse import OptionParser
import tm_graph
import pygame
import pygame.mixer
from pygame.locals import *
import tm_screen
import tm_recognizer
import tm_log
import tm_globals
from tm_globals import trace

usage = '''%prog [options] graph

required:
   graph           the name of the graph file
'''

def fit_img_horz(w, h, max_w, max_h):
    new_w = max_w
    new_h = int(h * float(max_w) / float(w))
    return (new_w, new_h)

def fit_img_vert(w, h, max_w, max_h):
    new_h = max_h
    new_w = int(w * float(max_h) / float(h))
    return (new_w, new_h)


#WINPORTdef convertNums(recogout):
#WINPORT    '''Will convert 'one' to 1, 'two' to 2, etc.'''
#WINPORT    newout = " "+recogout+" "
#WINPORT    if not re.match(' zero | one | two | three | four | five | six | seven | eight | nine ',newout):
#WINPORT        return recogout
#WINPORT    newout = re.sub(' zero ',' 0 ',newout)
#WINPORT    newout = re.sub(' one ',' 1 ',newout)
#WINPORT    newout = re.sub(' two ',' 2 ',newout)
#WINPORT    newout = re.sub(' three ',' 3 ',newout)
#WINPORT    newout = re.sub(' four ',' 4 ',newout)
#WINPORT    newout = re.sub(' five ',' 5 ',newout)
#WINPORT    newout = re.sub(' six ',' 6 ',newout)
#WINPORT    newout = re.sub(' seven ',' 7 ',newout)
#WINPORT    newout = re.sub(' eight ',' 8 ',newout)
#WINPORT    newout = re.sub(' nine ',' 9 ',newout)
#WINPORT    newout = newout.lstrip()
#WINPORT    newout = newout.rstrip()
#WINPORT    newout = re.sub(' ','_',newout)
#WINPORT    return newout[:3]
#WINPORT
def get_fkeys(keys):

    fkeys = []
    for i in range(0, len(keys)):
        if keys[i][0].lower() == "f1":
            fkeys.append((K_F1, keys[i][0]))
        elif keys[i][0].lower() == "f2":
            fkeys.append((K_F2, keys[i][0]))
        elif keys[i][0].lower() == "f3":
            fkeys.append((K_F3, keys[i][0]))
        elif keys[i][0].lower() == "f4":
            fkeys.append((K_F4, keys[i][0]))
        elif keys[i][0].lower() == "f5":
            fkeys.append((K_F5, keys[i][0]))
        elif keys[i][0].lower() == "f6":
            fkeys.append((K_F6, keys[i][0]))
        elif keys[i][0].lower() == "f7":
            fkeys.append((K_F7, keys[i][0]))
        elif keys[i][0].lower() == "f8":
            fkeys.append((K_F8, keys[i][0]))
        elif keys[i][0].lower() == "f9":
            fkeys.append((K_F9, keys[i][0]))
        elif keys[i][0].lower() == "f10":
            fkeys.append((K_F10, keys[i][0]))
        elif keys[i][0].lower() == "f11":
            fkeys.append((K_F11, keys[i][0]))
        elif keys[i][0].lower() == "f12":
            fkeys.append((K_F12, keys[i][0]))

    return fkeys


def play_blinks(blinks):

    for i in range(0, len(blinks)):
        (snd, cid) = blinks[i]

        channel = snd.play()

        pygame.time.wait(20)
        screen.set_cell_isflash(cid, True)
        screen.show()
        pygame.time.wait(tm_globals.flash_interval)
        screen.set_cell_isflash(cid, False)
        screen.show()

        while channel.get_busy() == True:
            # Busy wait...tsk.tsk.
            pygame.time.wait(10)


def get_input(screen, curNode, keys):
    "Get input from the user"

    recognizer = None

    # Check if this node requires recognition.
    if curNode.recog.has_key('label'):

        label = curNode.recog['label']

        # Start recognizer.
        trace("Starting recognizer.")
        sys.stdout.flush()

        # Length of prompt plus a little time to answer.
        recog_secs = 0
        for i in range(0, len(curNode.sounds)):
            recog_secs += curNode.sounds[i][1]
        recog_secs += 2.0

        screen.set_is_recording(True)
        recognizer = tm_recognizer.tm_recognizer(tm_globals.output_path,
                                                 recog_secs, label)
        recognizer.start()


       # Check in 2 seconds
        checkticks = pygame.time.get_ticks() + 2000
#WINPORT# 
#WINPORT#     if curNode == None:						     	
#WINPORT#         question = "Press any key to continue..."
#WINPORT#         font = None
#WINPORT#     else:
#WINPORT#         question = curNode.textbox['text']
#WINPORT#         font = curNode.textbox['font']

   #pygame.font.init()

        clock = pygame.time.Clock()
        current_string = ''
   #screen.set_ctltext(question + ":", font)

   # print "Starting loop."
        fkeys = get_fkeys(keys)

        while 1:

            clock.tick(60)

            ticks = pygame.time.get_ticks()

            # Give up some processing to HVite.
            pygame.time.wait(500)
            #time.sleep(1)

            if recognizer != None and ticks >= checkticks:
                # Check if recognizer has completed.
                (input, confidence) = recognizer.get_input()
                if (input != None):
                    trace("input=\"%s\" confidence=\"%f\"" % (input, confidence))
                    current_string = input
#WINPORT                    if (confidence >= tm_globals.def_min_conf):
#WINPORT                        current_string = input
#WINPORT                    else:
#WINPORT                        trace("Input does not pass confidence test. (%f < %f)" %
#WINPORT                               (confidence, tm_globals.def_min_conf) )
                    screen.set_is_recording(False)
                    screen.show()
                    break   # Exit loop
                else:
                    # Check again soon
                    checkticks = ticks + 100

            # Check for events.
            kb_finished = 0
            for event in pygame.event.get():
                if event.type == QUIT:
                    trace("Received QUIT event, exiting...")
                    sys.stdout.flush()
                    sys.exit(0)
                elif event.type == KEYUP:
                        if event.key == K_s:
                            tm_globals.session = tm_globals.session + 1
                            write_session(tm_globals.session)
                            trace("Incremented session id")
                elif event.type == KEYDOWN:

                    if event.key == K_ESCAPE:
                        trace("Recieved escape key, exiting...")
                        pygame.mixer.stop()
                        sys.stdout.flush()
                        sys.exit(0)

                    for i in range(0, len(fkeys)):
                        
                        if event.key == fkeys[i][0]:
                            trace("Recieved %s key." % fkeys[i][1])
                            current_string = fkeys[i][1]
                            kb_finished = 1

                    if curNode == None or event.key == K_RETURN:
                        kb_finished = 1
                    elif event.key == K_BACKSPACE:
                        current_string = current_string[:-1]
                    elif event.unicode:
                        current_string += event.unicode

                #screen.set_ctltext(question + ":" + current_string, font)
                screen.show()

            if kb_finished:
                break   # exit the while(1) loop

    #screen.set_ctltext(question + ":" + current_string, font)
    screen.show()

#WINPORT    if recognizer != None:
#WINPORT        if recognizer.get_state() == "running":
#WINPORT            recognizer.exit()

    return current_string


def read_session():

    # Default.
    session = 1

    # Read session file.
    if os.path.isfile(tm_globals.session_file):
        fd = open(tm_globals.session_file, 'r')
        while 1:
            l = fd.readline()
            if not l:
                fd.close()
                sys.exit("Error : bad session file format.")
            l = l.rstrip()
            if not l:
                fd.close()
                sys.exit("Error : bad session file format.")
            re_comment = re.compile(r'^#')
            re_session = re.compile(r'^(\d+)$')

            m = re_comment.match(l)
            if m:
                continue    # Skip comments
            m = re_session.match(l)
            if m:
                session = int(m.group(1))
                fd.close()
                break

    return session


def write_session(session):

    fd = open(tm_globals.session_file, 'w')

    fd.write("# Automatically generated session file.  " +
             "Edit with caution!\n")

    fd.write("%s\n" % session)

    fd.close()


if __name__ == '__main__':

    # Verify data directory.
    if not os.path.isdir(tm_globals.data_path):
        print("Data directory not found.  Creating one.")
        os.mkdir(tm_globals.data_path)

    if not os.path.isdir(tm_globals.output_path):
        print("Data directory not found.  Creating one.")
        os.mkdir(tm_globals.output_path)


    # Read the session ID and update it for the next run.
    tm_globals.session = read_session()
    tm_globals.session = tm_globals.session + 1
    write_session(tm_globals.session)

#WINPORT    # Verify disk space.
#WINPORT    if (tm_globals.get_disk_space() < tm_globals.min_disk_space):
#WINPORT        print("Error: Insufficient disk space, there will be no log or recording.")
#WINPORT        tm_globals.is_disk_space = False
#WINPORT
    # Create global logger instance.
    tm_globals.log = tm_log.tm_log(tm_globals.output_path)
    trace("---")
    trace("Starting %s version %s" % 
                    (tm_globals.application, tm_globals.version))


    #
    # Parse command line options.
    #
    parser = OptionParser(usage=usage)

    parser.add_option("-r", "--resolution",
        action="store", type="string", dest="resolution",
        help="Set screen resolution, eg: 640x480.", metavar="RESOLUTION")
    parser.add_option("-f", "--fullscreen",
        action="store_false", dest="fullscreen",
        help="Run in fullscreen mode.")
    parser.add_option("-n", "--node",
        action="store", type="string", dest="node",
        help="Set start node, eg: node1.", metavar="NODE")

    (options, args) = parser.parse_args()

    if (options.fullscreen == None):
        fullScreen = False
    else:
        fullScreen = True

    tm_globals.screen_width = tm_globals.def_width
    tm_globals.screen_height = tm_globals.def_height

    if (options.resolution != None):
        re_resolution = re.compile(r'^(?P<hrez>\d+)x(?P<vrez>\d+)')
        m = re_resolution.match(options.resolution)
        if m:
            tm_globals.screen_width = int(m.group('hrez'))
            tm_globals.screen_height = int(m.group('vrez'))
        else:
            sys.exit("Error : bad argument format: %s" %options.resolution)

    startNode = None
    if (options.node != None):
        startNode = options.node
    
    options,args = parser.parse_args()

    if (len(args) != 1):
        parser.print_help()
        sys.exit(1)
        
    graphFileName  = args[0]

    trace("screen is %dx%d (fullscreen = %s)" % \
        (tm_globals.screen_width, tm_globals.screen_height, fullScreen))
    trace("Graph file is \"%s\"" %graphFileName)

    if not os.path.exists(graphFileName):
        sys.exit("Error finding graph file: %s"%graphFileName)

    # Setup screen.
    #
    pygame.mixer.pre_init(tm_globals.sample_rate)
    pygame.init()

    if (fullScreen == True):
        screenSurface = pygame.display.set_mode((tm_globals.screen_width,tm_globals.screen_height), \
                                            FULLSCREEN)
    else:
        screenSurface = pygame.display.set_mode((tm_globals.screen_width,tm_globals.screen_height))

    pygame.display.set_caption(tm_globals.application)

    pygame.font.init()

    pygame.mouse.set_visible(0)

    screen = tm_screen.tm_screen(screenSurface, tm_globals.screen_width, tm_globals.screen_height)

    # Parse graph file.
    trace("Parsing graph file.")
    screen.show_loading(screenSurface)
    theGraph = tm_graph.tm_graph()
    theGraph.parse(graphFileName)
    trace("Finished parsing graph file.")

    if startNode != None:
        curNode = theGraph.getNode(startNode)
        if curNode == None:
            sys.exit("Error : specified node: \"%s\" does not exist." %startNode)
    else:
        curNode = theGraph.getStartNode()

    # lastNodeID = curNode.id
    if (re.compile(".*_title").match(curNode.id)):

        curStill = None
        stills  = curNode.stills
        for i in range(0, len(stills)):
            if (int(curNode.stills[i]['cell_id']) == 12):
                curStill = curNode.stills[i]

        # last image hack --------------------------------------------------------------

        img = curStill['image']

        # Calculate max image area based upon cell size.
        rect = tm_screen.get_image_rect(11)
        max_w = rect.width
        max_h = rect.height

        # Get actual image size.
        image_width = img.get_width()
        image_height = img.get_height()

        (new_w, new_h) = fit_img_horz(image_width, image_height, max_w, max_h) 
        if (new_h > max_h):
            (new_w, new_h) = fit_img_vert(image_width, image_height, max_w, max_h)

        img = pygame.transform.scale(img, (new_w, new_h))

        # Center image.
        left = (max_w - new_w) / 2
        top = (max_h - new_h) / 2

        last = (curNode.id, img, Rect(left, top, new_w, new_h), curStill['text'], curStill['font'])

        #-------------------------------------------------------------------------------

    while(curNode):

        trace("Node is: %s" % curNode.id)

        stills  = curNode.stills

        for i in range(0, len(stills)):
            # LAST cell.
            if (int(stills[i]['cell_id']) == 11):
                screen.set_cell_contents(11, last[1], last[2], last[3], last[4])
            else:
                screen.set_cell_contents(int(stills[i]['cell_id']),
                                         stills[i]['image'],
                                         stills[i]['imagerect'],
                                         stills[i]['text'],
                                         stills[i]['font'])

        inputs = curNode.inputs


        #txtPrompt = curNode.textbox['text']
        #font = curNode.textbox['font']
        #screen.set_ctltext(txtPrompt, font)
        #trace("%s: %s"%(curNode.id,txtPrompt))
        sys.stdout.flush()

        screen.show()


        blinks = curNode.blinks

        play_blinks(blinks)

        channel = None
        for i in range(0, len(curNode.sounds)):
            if channel == None:
                # Play the first sound.
                channel = curNode.sounds[i][0].play()
            else:
                # Queue remaining sounds.
                channel.queue(curNode.sounds[i][0])

        # Handle cases where the node just spits out a prompt
        # and doesn't need any input from the user. We just
        # move to the next node...
        fkeys = get_fkeys(curNode.keys)
        kb_finished = 0
        if len(inputs) == 1 and inputs[0][0].lower() == "all":
            (input, nextNodeID, flashIndex) = curNode.inputs[0]
            if pygame.mixer.get_busy() > 0:
                while pygame.mixer.get_busy():
                    time.sleep(0.1)
                    pygame.event.pump()
                    for event in pygame.event.get():
                        if event.type == QUIT:
                            trace("Received QUIT event, exiting...")
                            sys.stdout.flush()
                            sys.exit(0)			     	

                        if event.type == KEYUP:
                                if event.key == K_s:
                                    tm_globals.session = tm_globals.session + 1
                                    write_session(tm_globals.session)
                                    trace("Incremented session id")
                                    screen.show()

                        if event.type == KEYDOWN:
                            for i in range(0, len(fkeys)):
                                if event.key == fkeys[i][0]:
                                    trace("Recieved %s key." % fkeys[i][1])

                                    # Check if this was the "last" button.
                                    if (curNode.keys[i][1].lower() == "last"):
                                        #nextNodeID = lastNodeID
                                        nextNodeID = last[0]
                                    else:
                                        nextNodeID = curNode.keys[i][1]

                                    # Flash the cell.
                                    flash_cell = curNode.keys[i][2]

                                    screen.set_cell_isflash(flash_cell, True)
                                    screen.show()
                                    pygame.time.wait(tm_globals.flash_interval)
                                    screen.set_cell_isflash(flash_cell, False)
                                    screen.show()

                                if event.key == K_ESCAPE:
                                    trace("Recieved escape key, exiting...")
                                    pygame.mixer.stop()
                                    sys.stdout.flush()
                                    sys.exit(0)
                            else:
                                pygame.mixer.stop()
                    if kb_finished == 1:
                        break
            else:
                # get any input from the user and ignore it
                get_input(screen, None, [])


        else:
            # Get input from the user
            userInput = get_input(screen, curNode, curNode.keys)

            trace("user input is [%s]" % userInput)

            pygame.mixer.stop()

            nextNodeID = None
            flash_cell = None

            # Check if this was a button press.
            for i in range(0, len(curNode.keys)):
                if userInput == curNode.keys[i][0]:
                    # Check if this was the "last" button.
                    if (curNode.keys[i][1].lower() == "last"):
                        # nextNodeID = lastNodeID
                        nextNodeID = last[0]
                    else:
                        nextNodeID = curNode.keys[i][1]
                    flash_cell = curNode.keys[i][2]

            if nextNodeID == None:
                # Check the user's input against the list of allowable
                # responses and get the node id for their response
                # (If NR was defined for this node, then follow it. If
                # not, then just stay at the current node.)

                for i in range(0, len(curNode.inputs)):
                    if curNode.inputs[i][0] == userInput:
                        nextNodeID = curNode.inputs[i][1]
                        flash_cell = curNode.inputs[i][2]

                if nextNodeID == None:
                    if curNode.inputNR != None:
                        nextNodeID = curNode.inputNR
                    else:
                        trace("ERROR: input not allowed! Remaining at node.")
                        nextNodeID = curNode.id

            # Flash the answer cell.
            if (flash_cell != None) and (flash_cell != -1):
                screen.set_cell_isflash(flash_cell, True)
                screen.show()
                pygame.time.wait(tm_globals.flash_interval)
                screen.set_cell_isflash(flash_cell, False)
                screen.show()

        if (re.compile(".*_title").match(curNode.id)):
            # Remember this node id in case "last" is pressed.
            # lastNodeID = curNode.id
            curStill = None
            stills  = curNode.stills
            for i in range(0, len(stills)):
                if (int(curNode.stills[i]['cell_id']) == 12):
                    curStill = curNode.stills[i]
            # last image hack --------------------------------------------------------------

            img = curStill['image']

            # Calculate max image area based upon cell size.
            rect = tm_screen.get_image_rect(11)
            max_w = rect.width
            max_h = rect.height

            # Get actual image size.
            image_width = img.get_width()
            image_height = img.get_height()

            (new_w, new_h) = fit_img_horz(image_width, image_height, max_w, max_h) 
            if (new_h > max_h):
                (new_w, new_h) = fit_img_vert(image_width, image_height, max_w, max_h)

            img = pygame.transform.scale(img, (new_w, new_h))

            # Center image.
            left = (max_w - new_w) / 2
            top = (max_h - new_h) / 2

            last = (curNode.id, img, Rect(left, top, new_w, new_h), curStill['text'], curStill['font'])
            #-------------------------------------------------------------------------------

        # Erase the background for the old node
        screen.clear()
		    
        # Look for predefined stop node to exit the loop
        if nextNodeID.lower() != "stop":
            curNode = theGraph._nodes_[nextNodeID]
        else:
            curNode = None

    trace("Exiting %s" % tm_globals.application)
    sys.exit(0)

