#!/usr/bin/env python2.4
#

#WINPORTimport sys, threading, time, subprocess, ossaudiodev, re, os, struct
#WINPORTimport ossaudiodev, wave, math
import sys, threading, time, subprocess, re, os, struct
from tm_globals import trace, trace_cmd
import tm_globals
import pygame
import pygame.mixer
from pygame.locals import *

def print_cmd(cmd):
    for i in range(0, len(cmd)):
        sys.stdout.write("%s " % cmd[i])
    sys.stdout.flush()

class tm_recognizer(threading.Thread):

    def __init__(self, data_dir, seconds, label):
        threading.Thread.__init__(self)
        self.lock = threading.Lock()
        self.input = None
        self.confidence = 0.0
        self.data_dir = data_dir
        self.seconds = seconds
        self.label = label
        self.state = "init"

    def get_state(self):
            # Synchronize access.
            self.lock.acquire()
            state = self.state
            self.lock.release()
            return state

    def set_state(self, state):
            # Synchronize access.
            self.lock.acquire()
            self.state = state
            self.lock.release()

    def get_input(self):
            # Synchronize access.
            self.lock.acquire()
            input = self.input
            confidence = self.confidence
            self.lock.release()
            return (input, confidence)

    def set_input(self, input, confidence):
            # Synchronize access.
            self.lock.acquire()
            self.input = input
            self.confidence = confidence
            self.lock.release()

#WINPORT    def get_rms(self, bytes):
#WINPORT        # Compute the Root-Mean Squared (RMS) energy for the buffer.
#WINPORT        # Based upon Chuck Wooters routine.
#WINPORT
#WINPORT        sum = 0.0
#WINPORT        avg = 0.0
#WINPORT        length = len(bytes)
#WINPORT
#WINPORT        #print length
#WINPORT
#WINPORT        # Compute the square of each sample.
#WINPORT        i = 0
#WINPORT        while (i < length - 2):     # TODO: HACK - unpack can't read to end!?
#WINPORT            start = i
#WINPORT            end = i+2
#WINPORT            sample = int(struct.unpack("h", bytes[int(start):int(end)])[0])
#WINPORT            sum = sum + (sample * sample) 
#WINPORT            i = i + 2
#WINPORT
#WINPORT        #print "sum %d" % sum
#WINPORT
#WINPORT        # Compute the average of the squared values
#WINPORT        avg = sum / length
#WINPORT
#WINPORT        #print "avg %f" % avg
#WINPORT
#WINPORT        # Take the square root (could probably leave this out if it is slow...)
#WINPORT        return (math.sqrt(avg))
#WINPORT
#WINPORT
#WINPORT    def get_clicks(self, bytes):
#WINPORT
#WINPORT        clicks = []
#WINPORT
#WINPORT        length      = len(bytes)
#WINPORT        chunk_size  = int(tm_globals.sample_rate * .01) # 1/10 sec at a time.
#WINPORT        chunk_count = length / chunk_size
#WINPORT
#WINPORT        tcount = 0
#WINPORT        lasttriggered = 0
#WINPORT        bounce_min = 20     # Can't trigger within bounce_min time steps.
#WINPORT        for i in range(0, chunk_count):
#WINPORT
#WINPORT            start = (i * chunk_size)
#WINPORT            if (start + chunk_size) > length:
#WINPORT                end = length
#WINPORT            else:
#WINPORT                end = (i * chunk_size) + chunk_size
#WINPORT
#WINPORT            rms   = self.get_rms(bytes[int(start):int(end)])
#WINPORT     
#WINPORT            if rms > tm_globals.rms_thresh:
#WINPORT                tcount = tcount + 1
#WINPORT                if tcount >= tm_globals.rms_thresh_max and \
#WINPORT                                            (i - lasttriggered) > bounce_min:
#WINPORT                    lasttriggered = i;
#WINPORT                    tcount = 0;
#WINPORT                    #trace("click: %d" % start)
#WINPORT                    clicks.append(start)
#WINPORT            else:
#WINPORT                tcount = tcount - 1
#WINPORT                if tcount < 0:
#WINPORT                    tcount = 0
#WINPORT
#WINPORT        return clicks
#WINPORT
#WINPORT
    def run(self):

#WINPORT        self.set_state("running")
#WINPORT
#WINPORT        trace("Opening audio device.")
#WINPORT        self.dsp = ossaudiodev.open("/dev/dsp", "r")
#WINPORT        self.dsp.setfmt(ossaudiodev.AFMT_S16_LE)
#WINPORT        self.dsp.channels(tm_globals.channels)
#WINPORT        self.dsp.speed(tm_globals.sample_rate)
#WINPORT
#WINPORT        clicks = []
#WINPORT
#WINPORT        record_bytes = self.seconds * tm_globals.bps # Bytes to record.
#WINPORT        buf_size   = tm_globals.bps                 # Buffer one sec at a time.
#WINPORT        chunk_size = int(tm_globals.sample_rate * .01) # 1/10 sec at a time.
#WINPORT        bounce_min = 20     # Can't trigger within bounce_min time steps.
#WINPORT
#WINPORT        bytes_recorded = 0
#WINPORT        bytes = ""
#WINPORT        interrupt = False
#WINPORT        while bytes_recorded < record_bytes:
#WINPORT
#WINPORT            buffer = self.dsp.read(buf_size)
#WINPORT
#WINPORT            if tm_globals.def_detect_clicks == True:
#WINPORT                tmpClicks = self.get_clicks(buffer)
#WINPORT            else:
#WINPORT                tmpClicks = []
#WINPORT
#WINPORT            for i in range(0, len(tmpClicks)):
#WINPORT                clicks.append(tmpClicks[i] + bytes_recorded)
#WINPORT
#WINPORT            bytes_recorded += buf_size
#WINPORT            bytes += buffer
#WINPORT
#WINPORT            if (self.get_state() == "stopping"):
#WINPORT                trace("Closing audio device.")
#WINPORT                self.dsp.close()
#WINPORT                self.set_state("stopped")
#WINPORT                return
#WINPORT
#WINPORT            #if len(clicks) > 1:
#WINPORT            #    break
#WINPORT
#WINPORT        trace("Closing audio device.")
#WINPORT        self.dsp.close()
#WINPORT
#WINPORT        # Generate the wavefile name.
#WINPORT        wavename = "%d_%s" % (tm_globals.session, time.strftime("%Y%m%d_%H%M%S"))
#WINPORT        wavefile = "%s/%s.wav" % (self.data_dir, wavename)
#WINPORT        recfile = "%s/%s.rec" % (self.data_dir, wavename)
#WINPORT        trace("wavefile is %s" % wavefile)
#WINPORT        trace("recfile is %s" % recfile)
#WINPORT
#WINPORT#         # TODO:remove
#WINPORT#         fd = wave.open("%s/%s_all.wav" % (self.data_dir, wavename), 'w')
#WINPORT#         fd.setnchannels(tm_globals.channels)
#WINPORT#         fd.setsampwidth(2)
#WINPORT#         fd.setframerate(tm_globals.sample_rate)
#WINPORT#         fd.writeframes(bytes)
#WINPORT#         fd.close()
#WINPORT
#WINPORT        # Write wave data to output file.
#WINPORT        fd = wave.open(wavefile, 'w')
#WINPORT        fd.setnchannels(tm_globals.channels)
#WINPORT        fd.setsampwidth(2)
#WINPORT        fd.setframerate(tm_globals.sample_rate)
#WINPORT
#WINPORT        for i in range(0, len(clicks)):
#WINPORT            ms = (clicks[i] * 1000) / tm_globals.bps
#WINPORT            trace("click(unused) found at %d ms" % ms)
#WINPORT
#WINPORT#         num_clicks = len(clicks)
#WINPORT#         if (num_clicks) > 1:
#WINPORT#             start = clicks[0] + tm_globals.click_pre_pad
#WINPORT#             end = clicks[1] - tm_globals.click_post_pad
#WINPORT# #             trace("cutting at %d %d" % (start, end))
#WINPORT# #             if (start - end) < (tm_globals.bps / 10):
#WINPORT# #                 trace("Impossibly short segment, using all audio")
#WINPORT# #                 fd.writeframes(bytes)
#WINPORT# #             else:
#WINPORT#             fd.writeframes(bytes[int(start):int(end)])
#WINPORT#         else:
#WINPORT#             fd.writeframes(bytes)
#WINPORT        fd.writeframes(bytes)
#WINPORT
#WINPORT        fd.close()


        trace("Running recognizer")

        models = "%s/models.%s" % (tm_globals.recog_path, self.label)
        net    = "%s/net.%s"    % (tm_globals.recog_path, self.label)
        dict   = "%s/dict.%s"   % (tm_globals.recog_path, self.label)
        words  = "%s/words.%s"  % (tm_globals.recog_path, self.label)
        macros = "%s/macros.%s" % (tm_globals.recog_path, self.label)

        cmd = [ "HVite","-C","htk.conf", "-g", "%d" % self.seconds, "-H", macros, "-H", 
                models, "-w", net, "-p", "0.0", "-s", 
                "5.0", dict, words ];

        trace_cmd(cmd)

        (output, errors) = subprocess.Popen(cmd, stdin=subprocess.PIPE, 
                    stdout=subprocess.PIPE, 
                    stderr=subprocess.PIPE).communicate()

        if (len(errors) > 0):
            trace("HVite errors: \"%s\"" % errors)
            self.set_input("", 0)
            self.set_state("stopped")
            return

        #trace("output: %s" % output)

        lines = re.split('\n', output)
        for i in range(0, len(lines)):
            #trace("---")
            #trace("line >\"%s\"" % lines[i])
            re_beg = re.compile(r'^(.*?)\s+==')
            m = re_beg.match(lines[i])
            if m:
                beg = m.group(1)
                #trace("beg  >\"%s\"" % beg)

                re_label = re.compile(r'^(SENT-START\s+)*(.*?)(\s+SENT-END)*?$')
                m = re_label.match(beg)
                if m:
                    label = m.group(2)
                    trace("found label \"%s\"" % label)
                else:
                    trace("ERROR: HVite label parse failure: \"%s\"\n" % lines[0]);
                    self.set_input("", 0)
                    self.set_state("stopped")
                    return

        trace("Recognizer completed.")

#WINPORT        # Parse recognizer file.
#WINPORT        # sys.stdout.write("Parsing rec file...")
#WINPORT        # sys.stdout.flush();
#WINPORT
        confidence = 0.0    #TODO: Confidence disabled.
#WINPORT
#WINPORT        re_sil = re.compile(r'^\d+\s+\d+\s+sil\s+')
#WINPORT        re_label = re.compile(r'^(\d+)\s+(\d+)\s+(\w+)\s+(.+)')
#WINPORT
#WINPORT        fd = open(recfile, 'r')
#WINPORT        while 1:
#WINPORT            l = fd.readline()
#WINPORT            if not l:
#WINPORT                break
#WINPORT            l = l.rstrip()
#WINPORT            if not l:
#WINPORT                continue
#WINPORT            m = re_sil.match(l)
#WINPORT            if m:
#WINPORT                continue
#WINPORT            m = re_label.match(l)
#WINPORT            if m:
#WINPORT                start = int(m.group(1))
#WINPORT                end   = int(m.group(2))
#WINPORT                label = m.group(3)
#WINPORT                htkconf = float(m.group(4))
#WINPORT
#WINPORT                # Calculate confidence.
#WINPORT                confidence = htkconf / float(end - start)
#WINPORT
#WINPORT                #trace("start=%d end=%d conf=%f" % (start, end, htkconf))
#WINPORT                #trace("confidence=%f" % confidence)
#WINPORT
#WINPORT                break
#WINPORT
#WINPORT        fd.close()
#WINPORT
#WINPORT        if (tm_globals.is_disk_space == False) or (label == "SILENCE"):
#WINPORT            # Delete WAV and REC file.
#WINPORT            os.remove(wavefile)
#WINPORT            os.remove(recfile)
#WINPORT
#WINPORT        # sys.stdout.write("done.\n")
#WINPORT        # sys.stdout.flush();
#WINPORT
        self.set_input(label, confidence)
        self.set_state("stopped")

    def exit(self):
        if self.get_state() == "running":
            trace("Interrupting recognizer.")
            self.set_state("stopping")

        while (self.get_state() != "stopped"):
            time.sleep(1)

        trace("Recognizer stopped.")


if __name__ == '__main__':

    files = [ 
                "TMdata/output/169_20060408_114750_all.wav",
                ]

    recognizer = tm_recognizer(9999, tm_globals.output_path,
                               8, "recognizer-test")

    for i in range(0, len(files)):

        fd = wave.open(files[i], 'r')
        bytes = fd.readframes(1000000000)
        fd.close()

        clicks = recognizer.get_clicks(bytes)

        for i in range(0, len(clicks)):
            ms = (clicks[i] * 1000) / tm_globals.bps
            print ("click found at %d ms" % ms)

        dsp = ossaudiodev.open("/dev/dsp", "w")
        dsp.setfmt(ossaudiodev.AFMT_S16_LE)
        dsp.channels(tm_globals.channels)
        dsp.speed(tm_globals.sample_rate)
        fd = wave.open("tmp.wav", 'w')
        fd.setnchannels(tm_globals.channels)
        fd.setsampwidth(2)
        fd.setframerate(tm_globals.sample_rate)
        num_clicks = len(clicks)
        if (num_clicks) > 1:
            start = clicks[0] + tm_globals.click_pre_pad
            end = clicks[1] - tm_globals.click_post_pad
            dsp.writeall(bytes[int(start):int(end)])
            fd.writeframes(bytes[int(start):int(end)])
        else:
            dsp.writeall(bytes)
            fd.writeframes(bytes)

        dsp.close()
        fd.close()

        sys.exit()
